require 'AuthUtil'

class mthAuth
  def current_user
    if decoded_auth_token
      decoded_auth_token[:user_id]
    end
  end

  def decoded_auth_token
    @decoded_auth_token ||= AuthToken.decode(http_auth_header_content)
  end

  def auth_token_expired?
    decoded_auth_token && decoded_auth_token.expired?
  end

  def authenticate_request
    if auth_token_expired?
      raise AuthenticationTimeoutError
    elsif !decoded_auth_token[:user_id]
      raise NotAuthenticatedError
    end
  end

  def http_auth_header_content
    return @http_auth_header_content if defined? @http_auth_header_content
    @http_auth_header_content = begin
      if request.headers['Authorization'].present?
        request.headers['Authorization'].split(' ').last
      else
        nil
      end
    end
  end
end

